<link rel="import" href="../polymer/polymer-element.html">

<dom-module id="ciclo-vida">
  <template>
    <style>
      :host {
        display: block;
      }
      
    </style>
    <h2>Hello [[prop1]]!</h2>
  </template>

  <script>
    /**
     * `ciclo-vida`
     * 
     *
     * @customElement
     * @polymer
     * @demo demo/index.html
     */
    class CicloVida extends Polymer.Element {
      static get is() { return 'ciclo-vida'; }
      static get properties() {
        return {
          prop1: {
            type: String,
            value: 'ciclo-vida'
          }
        };
      }

      constructor(){
        super();
        console.log('Un elemento se ha creado');
      }
      connectedCallback(){
        super.connectedCallback();
        console.log('El elemento se ha introducido en el DOM');
      }
      disconnectedCallback() {
        super.disconnectedCallback();
        console.log('El elemento se ha retirado del DOM');
      }
      attributeChangeCallback(nombre, valorAnterior, valorNuevo){
        super.attributeChangeCallback(nombre, valorAnterior, valorNuevo);
        console.log('un atributo ha cambiado', nombre, valorAnterior, valorNuevo);
      }
      ready() {
        super.ready();
        console.log('Un elemento' + CicloVida.is + 'esta listo');
      }
    }

    window.customElements.define(CicloVida.is, CicloVida);
  </script>
</dom-module>
